/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  org.apache.log4j.Logger
 */
package fire.pb.main;

import fire.pb.main.ConfigManager;
import fire.pb.main.DAG;
import fire.pb.main.DAGNode;
import fire.pb.main.Gs;
import fire.pb.main.HotfixConfig;
import fire.pb.main.HotfixXml2ModuleConfig;
import fire.pb.main.ModuleInfo;
import fire.pb.main.ModuleInterface;
import fire.pb.main.ReloadResult;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.log4j.Logger;

public class ModuleManager {
    private static final Logger logger = Logger.getLogger((String)"SYSTEM");
    private static ModuleManager instance;
    private Map<String, ModuleInterface> modules;
    private ArrayList<String> 已初始化的模块;

    ModuleManager() {
    }

    private void initInstance() {
        if (!Gs.isInMainThread()) {
            throw new RuntimeException("不在主线程中");
        }
        this.modules = new ConcurrentHashMap<String, ModuleInterface>();
        DAG<ModuleInfo> dag = new DAG<ModuleInfo>();
        TreeMap<Integer, ModuleInfo> mconfig = ConfigManager.getInstance().getConf(ModuleInfo.class);
        for (ModuleInfo ml : mconfig.values()) {
            DAGNode<ModuleInfo> dg = dag.createNodeIfNotExist(ml);
            if (ml.dep == null) continue;
            for (String m : ml.dep) {
                for (ModuleInfo mi : mconfig.values()) {
                    if (!mi.name.equals(m)) continue;
                    dg.addPrev(mi);
                }
            }
        }
        final String[] foundError = new String[]{""};
        this.已初始化的模块 = new ArrayList(mconfig.size());
        dag.walk(new DAG.IWalk<ModuleInfo>(){

            @Override
            public void onNode(DAGNode<ModuleInfo> n) {
                Object obj;
                ModuleInfo mi = n.getName();
                String classname = mi.classname == null || mi.classname.isEmpty() ? "fire.pb." + mi.name + ".Module" : mi.classname;
                try {
                    obj = Class.forName(classname).newInstance();
                }
                catch (Exception ex) {
                    logger.error((Object)String.format("构造模块%s失败", mi.name), (Throwable)ex);
                    foundError[0] = mi.name;
                    return;
                }
                if (!(obj instanceof ModuleInterface)) {
                    logger.error((Object)String.format("模块%s配置错误", mi.name));
                    foundError[0] = mi.name;
                    return;
                }
                ModuleInterface m = (ModuleInterface)obj;
                try {
                    m.init();
                }
                catch (Exception ex) {
                    logger.error((Object)String.format("模块%s启动失败", mi.name), (Throwable)ex);
                    foundError[0] = mi.name;
                }
                ModuleManager.this.modules.put(mi.name, m);
                ModuleManager.this.已初始化的模块.add(mi.name);
            }
        });
        if (!foundError[0].isEmpty()) {
            this.exit();
            throw new RuntimeException("模块" + foundError[0] + "初始化失败");
        }
    }

    public static ModuleManager getInstance() {
        return instance;
    }

    static void init() {
        instance = new ModuleManager();
        instance.initInstance();
    }

    public synchronized ReloadResult reload() {
        List<String> reloadmodules = this.getReloadModules();
        ReloadResult result = new ReloadResult(true);
        for (String modulename : reloadmodules) {
            try {
                ModuleInterface module = ModuleManager.getInstance().getModuleByName(modulename);
                if (module == null) {
                    logger.error((Object)("Module: " + modulename + " is invalid. \n"));
                    return new ReloadResult(false, "module " + modulename + " is invalid. \n");
                }
                ReloadResult moduleresult = module.reload();
                if (moduleresult == null) {
                    return result;
                }
                result.appendResult(moduleresult);
                if (result.isSuccess()) {
                    result.appendMsg("Module: ").appendMsg(module.getClass().getName()).appendMsg("  reload success. \n");
                    continue;
                }
                return result;
            }
            catch (Exception e) {
                String errormsg = "Reload Module " + modulename + " Error. \n";
                logger.error((Object)errormsg, (Throwable)e);
                result.setSuccess(false);
                result.appendMsg(errormsg);
                return result;
            }
        }
        return result;
    }

    private List<String> getReloadModules() {
        TreeMap<Integer, HotfixConfig> hotfixs = ConfigManager.getInstance().getConf(HotfixConfig.class);
        LinkedList<String> reloadmodules = new LinkedList<String>();
        HashSet<String> reloadcfgs = new HashSet<String>();
        for (HotfixConfig hotfix : hotfixs.values()) {
            if (hotfix.type == 2) continue;
            reloadcfgs.add(hotfix.name);
        }
        for (HotfixXml2ModuleConfig xml2module : ConfigManager.getInstance().getConf(HotfixXml2ModuleConfig.class).values()) {
            if (!reloadcfgs.contains(xml2module.filename) || !xml2module.canreload || xml2module.module == null || xml2module.module.equals("") || reloadmodules.contains(xml2module.module)) continue;
            reloadmodules.add(xml2module.module);
        }
        return reloadmodules;
    }

    public ModuleInterface getModuleByName(String name) {
        return this.modules.get(name);
    }

    public ModuleInterface putModuleByName(String name, ModuleInterface m) {
        return this.modules.put(name, m);
    }

    void exit() {
        if (!Gs.isInMainThread()) {
            throw new RuntimeException("不在主线程中");
        }
        for (int i = this.已初始化的模块.size(); i != 0; --i) {
            try {
                this.modules.get(this.已初始化的模块.get(i - 1)).exit();
                continue;
            }
            catch (Exception ex) {
                logger.error((Object)"err", (Throwable)ex);
            }
        }
    }
}

